// KEdit.h: CKEdit NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KEDIT_H__A8AB72EC_7C07_11D3_8D95_F73642A56838__INCLUDED_)
#define AFX_KEDIT_H__A8AB72EC_7C07_11D3_8D95_F73642A56838__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KEditLine.h"
#include "Caret.h"
#include "KEditFont.h"
#include "UnReDo.h"
#include "KRegExp.h"

#define KEM_CURSORMOVE (WM_USER+0x0178+0)
#define KEM_CHANGED (WM_USER+0x0178+1)
#define KEM_CLEARED (WM_USER+0x0178+2)

class CKEdit
{
public:
	CKEdit();
	virtual ~CKEdit();

	// EChE֐
	void CreateWnd( HWND hP,HINSTANCE hI );
	HWND GetHwnd(){return m_hWnd;};
	// 񑀍֌W
	void ClearAll();
	CKEditLine* GetStart(){return m_pStart;};
	void LoadAtEnd( CKEditLine* p );

	void PublicInput( const char* pStr,int l ){ AddUndo(InputStr(pStr,l)); };
	void Delete();
	void Copy();
	void Cut();
	void Paste();
	void SelectAll(){	Move( m_TxtSize.cx-m_Cur.x,m_TxtSize.cy-m_Cur.y,false,false );
						Move( -m_Cur.x,-m_Cur.y,false,true ); };
	void Undo();
	void Redo();

	// ]ȃ
	void Compact();
	// \֌W
	void ChangeFont( CKEditFont* pF );
	const CKEditFont* GetFont(){return m_pFont;};

	// EWv
	void Jump( unsigned long line ){MoveTo(0,line-1,false,false);};
	bool FindNext( CKFind* pFinder );

protected:
	// 񑀍֌W
	int GetSelByte();
	void GetSel(char* pBuf);
	CUnReDo* DeleteSel();
	CUnReDo* InputStr( const char* pStr , int l );
	CUnReDo* Del();
	CUnReDo* BackSpace();

	static LRESULT CALLBACK EditWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	void Activate(bool b);
	void Draw( PAINTSTRUCT* ps );
	void ReDraw(POINT from,POINT to);
	void ReDrawAfter( POINT from );
	void ReDrawLine( POINT from );
	// TCY
	void Resize( int cx,int cy );
	// XN[
	void VScroll(int dif);
	void HScroll(int dif);
	void ScrollCaretIn();
	void SetScrollSize(bool bCalc);
	// J[\
	CKEditLine* GetBuffer(int PosY);
	void Move( int dx,int dy,bool bRight,bool bSelect );
	void MoveTo( int x,int y,bool bRight,bool bSelect ){Move( x-m_Cur.x , y-m_Cur.y , bRight , bSelect );};
	// Undo
	void AddUndo( CUnReDo* u );

private:
	// EChEYIɕKvȃnh
	HWND m_hWnd;
	HWND m_hParent;

	bool m_bLocked;

	// XN[֌W
	SIZE m_WndSize;

	// Jbg֌W
	CCaret m_Caret;
	POINT m_Cur,m_Sel;
	int m_VirtX;

	CKEditLine* m_pTop;
	POINT m_Ori;

	// tHg֌W
	CKEditFont *m_pFont;
	CKEditFont m_DefaultFont;
	HFONT m_hFont;
	HBRUSH m_hBg;
	// f[^֌W
	CKEditLine* m_pStart;
	SIZE m_TxtSize;
	// Undo , Redo
	CUnReDo *m_pUndo,*m_pRedo;
};

#endif // !defined(AFX_KEDIT_H__A8AB72EC_7C07_11D3_8D95_F73642A56838__INCLUDED_)
