// KEditLine.cpp: CKEditLine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "KEditLine.h"
#include "util.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CKEditLine::CKEditLine()
{
	len = 0;
	alen=10;
	buf = new char[alen];

	m_Width = 0;

	m_pNext = m_pPrev = false;
}

CKEditLine::~CKEditLine()
{
	delete [] buf;
}

void CKEditLine::Alloc(int size)
{
	if( alen>=size )
		return;
	alen=size;
	char* p = new char[alen];
	CopyMemory(p,buf,len);
	delete [] buf;
	buf = p;
}

void CKEditLine::ReAlloc()
{
	char* p = new char[alen=len];
	CopyMemory(p,buf,len);
	delete [] buf;
	buf = p;
}

void CKEditLine::InsertAfter( CKEditLine* pL )
{
	pL->m_pPrev = this;
	pL->m_pNext = m_pNext;
	if( m_pNext!=NULL )
		m_pNext->m_pPrev = pL;
	m_pNext = pL;
}

void CKEditLine::InsertBefore( CKEditLine* pL )
{
	pL->m_pPrev = m_pPrev;
	pL->m_pNext = this;
	if( m_pPrev!=NULL )
		m_pPrev->m_pNext = pL;
	m_pPrev = pL;
}

void CKEditLine::Draw(HDC hdc,const CKEditFont* pF,RECT* rc)
{
	int t;
	int x=rc->left,y=rc->top;

	COLORREF curcl=pF->Txt;
	SetTextColor(hdc,curcl);

	int i=0;
	while( i<len )
	{
		if( buf[i]=='\t' )
		{
			SetTextColor(hdc,pF->Ctrl);
			TextOut( hdc, x, y, ">",1 );
			SetTextColor(hdc,curcl);

			x = ((x-rc->left)/(pF->Size.cx*pF->Tab)+1)*(pF->Size.cx*pF->Tab)+rc->left;
			i++;
		}
		else
		{
			if( IsLead( buf[i] ) && i+1!=len )	t=2;
			else								t=1;
/*ˑRsRgF(^^;
			if( buf[i]=='/' && buf[i+1]=='/' )
			{
				curcl=pF->Comment;
				SetTextColor(hdc,curcl);
			}
*/
			if( x+pF->Size.cx*t > 0 )
				TextOut( hdc, x, y, &buf[i],t );
			x+=pF->Size.cx*t;
			i+=t;
		}

		if( x>rc->right )
			break;
	}

	if( i>=len )
	{
		SetTextColor(hdc,pF->Ctrl);
		if( GetNext()!=NULL )	TextOut( hdc, x, y, "/",1 );
		else					TextOut( hdc, x, y, "[EOF]",5);
		SetTextColor(hdc,pF->Txt);
	}
}

void CKEditLine::AddTail( char s1 , char s2 , const CKEditFont* pF )
{
	if( len>alen-2 )
		Alloc(alen<<1);

	if( s2=='\0' )
	{
		buf[len]=s1;
		len++;
		if( s1=='\t' )
			m_Width = ((m_Width/pF->Tab)+1)*(pF->Tab);
		else
			m_Width ++;
	}
	else
	{
		buf[len]=s1;
		buf[len+1]=s2;
		len+=2;
		m_Width += 2;
	}
}

// AhX&buf[pos]̂ƂɃoCgs}
void CKEditLine::InsertStr( int pos,const char* s,int l,const CKEditFont* pF )
{
	Alloc(len+l);
	MoveMemory(&buf[pos+l],&buf[pos],len-pos);
	CopyMemory(&buf[pos],s,l);
	len+=l;

	CalcWidth(pF);
}

// buf[from]buf[to-1]܂ł苎āA납l߂B
void CKEditLine::Remove( int from,int to,const CKEditFont* pF )
{
	MoveMemory( &buf[from],&buf[to],len-to );
	len -= (to-from);
	CalcWidth(pF);
}

void CKEditLine::CalcWidth( const CKEditFont* pF )
{
	int w=0;

	int i=0;
	while( i<len )
	{
		if( buf[i]=='\t' )
		{
			w = (w/pF->Tab+1)*pF->Tab;
			i++;
		}
		else
		{
			if( IsLead( buf[i] ) && i+1!=len )	w+=2,i+=2;
			else								w++,i++;
		}
	}
	m_Width = w;
}

// xWindexɕϊ( bRight  W[ȂƂɉEɊ񂹂Ȃtrue )
int CKEditLine::Pos2Address( int p,bool bRight,const CKEditFont* pF )
{
	if( p==0 )		return 0;

	if( bRight )
	{
		if( p<0 )	return 0;
		if( m_pNext==NULL )
		{
			if( p>=m_Width )return len;
		}
		else
		{
			if( p>m_Width )	return -1;
			if( p==m_Width )return len;
		}
	}
	else
	{
		if( p<0 )	return -1;
		if( p>=m_Width )	return len;
	}

	int t=0,i2=0;
	for( int i=0; i<len; i++ )
	{
		if( t==p )			return i;
		if( bRight && t>p )	return i;
		else if( t>p )		return i2;

		i2=i;

		if( buf[i]=='\t' )	t = (t/pF->Tab+1)*pF->Tab;
		else
		{
			if( IsLead( buf[i] ) && i+1!=len )	i++,t+=2;
			else								t++;
		}
	}
	if( bRight )	return i;
	return i2;
}

// indexxWɕϊ
int CKEditLine::Address2Pos( int a,const CKEditFont* pF )
{
	int w=0;
	int i=0;
	while( i<a )
	{
		if( buf[i]=='\t' )
		{
			w = (w/pF->Tab+1)*pF->Tab;
			i++;
		}
		else
		{
			if( IsLead( buf[i] ) && i+1!=len )	w+=2,i+=2;
			else								w++,i++;
		}
	}
	return w;
}
