
#include "stdafx.h"
#include "KFile.h"

bool CKFile::Open( const char* fname,bool bReadMode,bool bCreate )
{
	Close();

	if( bReadMode )
		m_hFile=CreateFile( fname,GENERIC_READ,FILE_SHARE_READ,NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL );
	else
		m_hFile=CreateFile( fname,GENERIC_WRITE,FILE_SHARE_READ,NULL,
				bCreate?CREATE_ALWAYS:OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL );
	if( m_hFile==INVALID_HANDLE_VALUE )
		return false;

	m_bReadMode=bReadMode;

	m_pBuf = new BYTE[KFILE_BUFSIZE];
	m_nBufPos = 0;
	if( m_bReadMode )Flush();

	return true;
}

void CKFile::Close()
{
	if( m_hFile!=INVALID_HANDLE_VALUE )
	{
		if( !m_bReadMode )
			Flush();

		CloseHandle(m_hFile);
		m_hFile=INVALID_HANDLE_VALUE;

		delete [] m_pBuf;
		m_pBuf=NULL;
	}
}

DWORD CKFile::Read( BYTE* dat,DWORD len )
{
	DWORD ans=0;
	if( m_hFile==INVALID_HANDLE_VALUE || !m_bReadMode )
		return ans;
	if( m_nBufSize==0 )
		return ans;

	while( m_nBufSize-m_nBufPos <= (int)len )
	{
		ans+=m_nBufSize-m_nBufPos;
		CopyMemory( dat,m_pBuf+m_nBufPos, m_nBufSize-m_nBufPos );
		len -= m_nBufSize-m_nBufPos;
		dat += m_nBufSize-m_nBufPos;
		Flush();
		if( m_nBufSize==0 )
			return ans;
	}
	ans +=len;
	CopyMemory( dat, m_pBuf+m_nBufPos, len );
	m_nBufPos += len;

	return ans;
}

void CKFile::Write( BYTE* dat,DWORD len )
{
	if( m_hFile==INVALID_HANDLE_VALUE || m_bReadMode )
		return;

	while( KFILE_BUFSIZE-m_nBufPos <= (int)len )
	{
		CopyMemory( m_pBuf+m_nBufPos, dat, KFILE_BUFSIZE-m_nBufPos );
		len -= KFILE_BUFSIZE-m_nBufPos;
		dat += KFILE_BUFSIZE-m_nBufPos;
		m_nBufPos = KFILE_BUFSIZE;
		Flush();
	}
	CopyMemory( m_pBuf+m_nBufPos, dat, len );
	m_nBufPos += len;
}

void CKFile::Flush()
{
	if( m_bReadMode )
	{
		ReadFile( m_hFile,m_pBuf,KFILE_BUFSIZE,(DWORD*)&m_nBufSize,NULL );
		m_nBufPos=0;
	}
	else
	{
		// m_nBufSize͏ݎɂ͊֌WȂB_~[B
		WriteFile( m_hFile,m_pBuf,m_nBufPos,(DWORD*)&m_nBufSize,NULL );
		m_nBufPos=0;
	}
}
